CodeForces 734E Anton and Tree

$dfs$缩点,树形$dp$。

首先将连通块缩点,缩点后形成一个黑白节点相间的树。接下来的任务就是寻找一个$root$,使这棵树以$root$为根,树的高度是最小的(也就是一层一层染色)。树形$dp$可以解决这个问题,第一次$dfs$处理子树,第二次$dfs$枚举$root$计算答案。

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<ctime>
#include<iostream>
using namespace std;
typedef long long LL;
const double pi=acos(-1.0);
void File()
{
    freopen("D:\\in.txt","r",stdin);
    freopen("D:\\out.txt","w",stdout);
}
template <class T>
inline void read(T &x)
{
    char c = getchar();
    x = 0;
    while(!isdigit(c)) c = getchar();
    while(isdigit(c))
    {
        x = x * 10 + c - ‘0‘;
        c = getchar();
    }
}

int n;
int c[200010];
int nc[200010];
int u[200010];
int v[200010];
int belong[200010];
int block;
vector<int>G[200010];
int flag[200010];
vector<int>L[200010],R[200010];
int ans;

int a[200010];

void dfs(int x)
{
    belong[x]=block;
    for(int i=0;i<G[x].size();i++)
    {
        int to=G[x][i];
        if(c[to]!=c[x]) continue;
        if(belong[to]!=0) continue;
        dfs(to);
    }
}

void dp(int x)
{
    flag[x]=1;

    int mx=0;
    for(int i=0;i<G[x].size();i++)
    {
        int to=G[x][i];
        if(flag[to])
        {
            L[x].push_back(mx);
            continue;
        }

        dp(to);
        mx=max(mx,a[to]);
        L[x].push_back(mx+1);
    }
    a[x]=mx+1;
}

void dp2(int x)
{
    flag[x]=1;

    int mx=0;
    for(int i=G[x].size()-1;i>=0;i--)
    {
        int to=G[x][i];
        if(flag[to])
        {
            R[x].push_back(mx);
            continue;
        }

        dp2(to);
        mx=max(mx,a[to]);
        R[x].push_back(mx+1);
    }
    a[x]=mx+1;
}

void Find(int x,int h)
{
    flag[x]=1;

    int nh;
    int sz=G[x].size();
    for(int i=0;i<G[x].size();i++)
    {
        int root=G[x][i];
        if(flag[root]) continue;

        nh=h+1;

        int k=0;
        if(i-1>=0) k=max(k,L[x][i-1]);
        if(sz-i-2>=0) k=max(k,R[x][sz-i-2]);
        if(k!=0) nh=max(nh,k+1);

        ans=min(ans,max(nh,a[root]));
        Find(root,nh);
    }
}

int main()
{
    cin>>n;
    for(int i=1;i<=n;i++) cin>>c[i];
    for(int i=1;i<=n-1;i++)
    {
        cin>>u[i]>>v[i];
        G[u[i]].push_back(v[i]);
        G[v[i]].push_back(u[i]);
    }

    for(int i=1;i<=n;i++)
    {
        if(belong[i]!=0) continue;
        block++; nc[block]=c[i]; dfs(i);
    }

    for(int i=1;i<=n;i++) G[i].clear();

    for(int i=1;i<=n-1;i++)
    {
        if(c[u[i]]==c[v[i]]) continue;
        G[belong[u[i]]].push_back(belong[v[i]]);
        G[belong[v[i]]].push_back(belong[u[i]]);
    }

    memset(flag,0,sizeof flag); dp(1);
    memset(flag,0,sizeof flag); dp2(1);

    ans=a[1];
    memset(flag,0,sizeof flag); Find(1,1);

    printf("%d\n",ans-1);

    return 0;
}
时间: 2024-12-29 03:29:51

CodeForces 734E Anton and Tree的相关文章

Codeforces 461B Appleman and Tree(木dp)

题目链接:Codeforces 461B Appleman and Tree 题目大意:一棵树,以0节点为根节点,给定每一个节点的父亲节点,以及每一个点的颜色(0表示白色,1表示黑色),切断这棵树的k条边,使得树变成k+1个联通分量.保证每一个联通分量有且仅有1个黑色节点.问有多少种切割方法. 解题思路:树形dp,dp[i][0]和dp[i][1]分别表示子树一下的切割方法中,i节点所在联通块不存在黑节点和已经存在一个黑节点的方案数. #include <cstdio> #include &l

codeforces 161D - Distance in Tree(树形dp)

题目大意: 求出树上距离为k的点对有多少个. 思路分析: dp[i][j] 表示 i 的子树中和 i 的距离为 j 的点数有多少个.注意dp[i] [0] 永远是1的. 然后在处理完一颗子树后,就把自身的dp 更新. 更新之前更新答案. 如果这颗子树到 i 有 x 个距离为j的.那么答案就要加上 dp[i] [ k-j-1] * x; #include <iostream> #include <cstdio> #include <cstring> #include &l

Codeforces 461B Appleman and Tree(树形dp)

题目链接:Codeforces 461B Appleman and Tree 题目大意:一棵树,以0节点为根节点,给定每个节点的父亲节点,以及每个点的颜色(0表示白色,1表示黑色),切断这棵树的k条边,使得树变成k+1个联通分量,保证每个联通分量有且仅有1个黑色节点.问有多少种分割方法. 解题思路:树形dp,dp[i][0]和dp[i][1]分别表示子树一下的分割方法中,i节点所在联通块不存在黑节点和已经存在一个黑节点的方案数. #include <cstdio> #include <c

Educational Codeforces Round 25 G. Tree Queries

题目链接:Educational Codeforces Round 25 G. Tree Queries 题意: 给你一棵树,一开始所有的点全是黑色,有两种操作. 1 x 将x这个点变为黑色,保证第一个操作是这个. 2 x 询问x到任意黑色的点的简单路径上的最小节点编号. 题解: 首先将一个变为黑色的点当成树根,然后dfs一下,预处理出所有点的答案. 然后开一个变量记录一下当前变黑的点的答案cur=min(cur,dp[x]). 每次询问的时候答案就是min(cur,dp[x]). 如果觉得很神

Codeforces.280C.Game on Tree(期望)

题目链接 参考:浅谈期望的线性性(可加性) Codeforces 280C Game on Tree 概率dp 树上随机删子树 求删完次数的期望(这个的前半部分分析并没有看..) \(Description\) 给你一棵有\(n\)个白点的有根树,每次随机选择一个点,将它和它的子树中所有点染黑. 问期望操作多少次后所有点都被染黑? \(Solution\) 期望好玄啊..(好吧是我太弱) 因为概率具有可加性,一棵树可以分解为多棵子树,而子树分解的最终状态就是点,所以我们可以计算每个点的期望操作次

Codeforces Round #379 (Div. 2) E. Anton and Tree

题意:给你一棵树, 每个点要么是黑色要么是白色, 有一种操作是将同一个颜色的连通块变成相反的颜色,问你最少变换几次, 整颗树变成一种颜色. 思路: 缩点, 加求树的直径, 答案为树的直径除二向上取整. 1 #include<bits/stdc++.h> 2 #define LL long long 3 #define mk make_pair 4 using namespace std; 5 6 const int N = 5e5 + 7; 7 const int inf = 0x3f3f3f

CodeForces 396C On Changing Tree

On Changing Tree Time Limit: 2000ms Memory Limit: 262144KB This problem will be judged on CodeForces. Original ID: 396C64-bit integer IO format: %I64d      Java class name: (Any) You are given a rooted tree consisting of n vertices numbered from 1 to

Codeforces 348B:Apple Tree(DFS+LCM+思维)

http://codeforces.com/contest/348/problem/B 题意:给一棵树,每个叶子结点有w[i]个苹果,每个子树的苹果数量为该子树所有叶子结点苹果数量之和,要使得每个结点的各个子树苹果数量相等,求至少需要拿走的苹果数量. 思路:一开始以为只要使得所有子树之和相同就行了. 1 void dfs(int u, int fa) { 2 int num = 0, mi = INF; 3 for(int i = head[u]; ~i; i = edge[i].nxt) {

【CodeForces】343D Water tree (线段树好题!还未弄懂)

/* 此题的方法除了用线段树求子树,通过标记父亲,更新儿子的方法,来更新祖先,学习了. 对于建树的方法由于并没有说明父亲与儿子的顺序,所以需要通过两次添加. 并且pre变量可以获得父亲的位置,还未弄懂! */ #define _CRT_SECURE_NO_WARNINGS #include<cstring> #include<cstdio> #include<iostream> #include<algorithm> using namespace std;